if pcount()<>0
    altd()
endif
do bodywork
* set procedure to CUSTYPFN additive
* set procedure to HOUSE00 additive
* set procedure to INV00 additive
* set procedure to INV01 additive
* set procedure to INVSCRN additive
* set procedure to INVSLCT additive
* set procedure to PARTFUNC additive
* set procedure to QBDBFUNC additive
* set procedure to QBIPROC additive
* set procedure to QBPROCS additive
* set procedure to QBTXTMAC additive
* set procedure to REP00 additive
quit

function gotop
go top
return reccount()

function qbskip
parameters nSkip
skip nSkip
return recno()


procedure BODYWORK
*** BODY00.PRG : Main menu.
***

do QBINIT
do BODYINIT

private MAINCH

do while .t.

    do QBLAYOUT with "Main menu"
    do QBBOX with 40
    MAINCH = QBMENU("MAIN",30)

    do case
    case MAINCH=0 .or. MAINCH=4
        if QBYESNO("Do you really wish to Quit now?")="Y"
            exit
        endif
    case MAINCH=1
        do INVMAIN
    case MAINCH=2
         do REPMAIN
    case MAINCH=3
         do HOUSEMAIN
    endcase
    QBCHOICE = MAINCH

enddo

close database
clear
?? "Exit "+trim(QBTITLE)+" application"
quit

*******************************************************************

procedure BODYINIT
*       B O D Y I N I T

*       INVOICE Information

public MINVNO, MSPEEDO, MFUEL, MPARTDISC, MVATRATE, MOWNNAME, MOWNADD1
public MOWNADD2, MOWNADD3, MMAKEMODEL, MINSCO, MINSADD1, MINSADD2, MINSENG
public MINSTEL, MPAINT, MOWNTELH, MOWNTELB, MOWNVAT, MINSTOPAY, MACTYPE
public MWORKTYPE, MDATEIN, MDATEOUT, MDATEINV, MREGNO, MYEAR, MENGNO
public MCHASNO, MESTNO, MLABESTNO, MCLAIMNO, MLABOUR1, MLABOUR2, MLABOUR3
public MLABOUR4, MLABOURT, MINSLAB, MOWNLAB, MINSPART, MOWNPART, MINSSPEC
public MOWNSPEC, MINSAMT, MOWNAMT, MEXCESS, MCONTRIB, MINSDUE, MOWNDUE
public MINVTOTAL, MCUSTTYP, ML2TEXT, ML3TEXT, ML4TEXT, MTRIM
public MPARTSPEC, MPARTDESC, MQTY, MTPRICE, MUPRICE, MOWNINIT
public IPDSCNT, OPDSCNT, ISUBTOT, OSUBTOT, IVATAMT, OVATAMT, INSSUB, OWNSUB
public MCTYPE, MCDESC, MADD, MPLINENO, MEDITING, AUTOADD
* public PARTFLDS[5], PARTHDRS[5], PARTPICS[5]
public PARTFLDS[4], PARTHDRS[4], PARTPICS[4]

INVCLEAR()
PARTCLEAR()
store space(4) to MCUSTTYP
store space(35) to MCDESC
store .f. to MADD, MEDITING, AUTOADD

PARTHDRS[1] = " Description"
PARTFLDS[1] = "PARTDESC"
PARTPICS[1] = replicate("X",15)
PARTHDRS[2] = "Qty"
PARTFLDS[2] = "QTY"
PARTPICS[2] = "99"
PARTHDRS[3] = " Unit P"
PARTFLDS[3] = "UPRICE"
PARTPICS[3] = "9999.99"
PARTHDRS[4] = "Total P"
PARTFLDS[4] = "TPRICE"
PARTPICS[4] = "9999.99"
*PARTHDRS[5] = "Part/Spec"
*PARTFLDS[5] = "PARTSPEC"
*PARTPICS[5] = "@R     !"

return

*******************************************************************

function V2DATES
*       Vali DATE ha ha
parameters otherd, TESTYPE
private RETVAL, MEM, VARNAME

VARNAME = readvar()
MEM = &VARNAME
if (empty(MEM) .or. empty(OTHERD)) .and. TESTYPE>0
    return .t.
else
    TESTYPE = abs(TESTYPE)
endif

do case
case TESTYPE=1
    RETVAL = (MEM<=OTHERD)
case TESTYPE=2
    RETVAL = (MEM>=OTHERD)
case TESTYPE=3
    RETVAL = (MEM<OTHERD)
case TESTYPE=4
    RETVAL = (MEM>OTHERD)
otherwise
    RETVAL = .t.
endcase

return RETVAL

*****************************************************************

function PRPOS
parameters NUM, PIC
private PLEN, RETVAL

if NUM>0
    RETVAL = transform(NUM,PIC)
else
    RETVAL = space(len(PIC))
*    RETVAL = replicate("#",len(PIC))
endif

return RETVAL

**************************************************************

function NEWNUM
*       Validate New Invoice number
parameters PRMSG
if pcount()=0
    PRMSG = .f.
endif
private SELNO, RETVAL, OLDSCR, MEM, VARNAME

if PRMSG
    VARNAME = readvar()
    MEM = &VARNAME
else
    MEM = MINVNO
endif
SELNO = select()

select INVOICE
set index to INVNUM
set softseek off
seek str(MEM,5)
RETVAL = eof() .and. MEM>0
if (.not. RETVAL) .and. PRMSG
    OLDSCR = savescreen(0,0,1,79)
    do QBMESS with "Invoice already exists",colflash,3
    restscreen(0,0,1,79,OLDSCR)
endif
select (SELNO)

return RETVAL
